C-----------------------------------------------------------------------------
C FILE: mpi_bug5.f
C   This is an "unsafe" program. Be sure to set the following environment
C   variables to demonstrate the point:
C     unsetenv MP_SHARED_MEMORY
C     setenv MP_CSS_INTERRUPT yes
C     setenv MP_USE_FLOW_CONTROL no
C   It should fail. Then "unsetenv" the MP_CSS_INTERRUPT and MP_USE_FLOW_CONTROL
C   variables and run it again. It should run forever this time. 
C SOURCE: Blaise Barney 03/02/02
C LAST REVISED: 01/14/04
C-----------------------------------------------------------------------------

      program mpi_bug5
      include 'mpif.h'

      integer   MSGSIZE
      parameter (MSGSIZE = 4096)
      
      integer numtasks, rank, i, tag, dest, source, count, forever
      character data(MSGSIZE)
      real*8 start, end, result
      real anum
      integer status(MPI_STATUS_SIZE)
     
      tag = 111
      dest = 1
      source = 0
      count = 0
      forever = 1

      call MPI_INIT(ierr)
      call MPI_COMM_SIZE(MPI_COMM_WORLD, numtasks, ierr)
      call MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)

      if (rank .eq. 0) then
        print *, 'mpi_bug5 has started...'
        if (numtasks .gt. 2) then
          print *, 'INFO: Number of tasks=',numtasks,
     +             '. Only using 2 tasks.'
        endif
      endif


C******************************* Send task **********************************/
      if (rank .eq. 0) then
C       Initialize send data
        do i=1, MSGSIZE
          data(i) = 'x'
        enddo

        start = MPI_WTIME()
        do while (forever .eq. 1)
          call MPI_SEND(data, MSGSIZE, MPI_BYTE, dest, tag, 
     +                  MPI_COMM_WORLD, ierr)
          count = count + 1
          i = MOD(count, 1000)
          if (i .eq. 0) then
            end = MPI_WTIME()
            print *, 'Count=',count,'Time=',end-start,'sec.'
            start = MPI_WTIME()
          endif
        enddo
      endif


C****************************** Receive task ********************************/

      if (rank .eq. 1) then
        do while (forever .eq. 1)
          call MPI_RECV(data, MSGSIZE, MPI_BYTE, source, tag, 
     +         MPI_COMM_WORLD, status, ierr)
C         Do some work  - at least more than the send task
          result = 0.0
          do i=1, 1000000
            call RANDOM_NUMBER(anum)
            result = result + anum
          enddo
        enddo
      endif

      call MPI_FINALIZE(ierr)
      end
