##############################################################################
# Makefile for all Serial C Language example codes
# LAST REVISED:  12/27/2001 Blaise Barney
###############################################################################
CC      =   xlc
FLAGS   =   -O2

all:    ser_2dfft       \
        ser_array       \
        ser_heat2D      \
        ser_mm          \
        ser_pi_calc     \
        ser_prime       \
        ser_wave 

clean:  
	/bin/rm -ef     \
	initial.dat     \
	final.dat       \
	ser_2dfft       \
	ser_array       \
	ser_heat2D      \
	ser_mm          \
	ser_pi_calc     \
	ser_prime       \
	ser_wave        \
        *.o


ser_2dfft:  ser_2dfft.c ser_fft.o ser_fft.h
	$(CC) $(FLAGS) ser_2dfft.c  ser_fft.o -o ser_2dfft -lm

ser_array: ser_array.c
	${CC} ${FLAGS} ser_array.c -o ser_array 

ser_fft.o:  ser_fft.c
	$(CC) $(FLAGS) -c ser_fft.c 

ser_heat2D: ser_heat2D.c
	${CC} ${FLAGS} ser_heat2D.c -o ser_heat2D 

ser_mm: ser_mm.c
	${CC} ${FLAGS} ser_mm.c -o ser_mm 

ser_pi_calc: ser_pi_calc.c
	${CC} ${FLAGS} ser_pi_calc.c -o ser_pi_calc 

ser_prime: ser_prime.c
	${CC} ${FLAGS} ser_prime.c -o ser_prime  -lm

ser_wave: ser_wave.c
	${CC} ${FLAGS} ser_wave.c -o ser_wave -lm

