##############################################################################
# Makefile for all Serial Fortran example codes
# LAST REVISED:  12/27/2001 Blaise Barney
###############################################################################
F77     =   xlf
CC 	=   xlc
FLAGS   =   -O2

all:    ser_2dfft       \
        ser_array       \
        ser_heat2D      \
        ser_mm          \
        ser_pi_calc     \
        ser_prime       \
        ser_wave 

clean: 
	/bin/rm -ef     \
	initial.dat     \
	final.dat       \
	ser_2dfft       \
	ser_array       \
	ser_heat2D      \
	ser_mm          \
	ser_pi_calc     \
	ser_prime       \
	ser_wave        \
	*.o


ser_2dfft:  ser_2dfft.f ser_fft.o timing_fgettod.o
	$(F77) $(FLAGS) ser_2dfft.f ser_fft.o timing_fgettod.o  -o ser_2dfft 

ser_array: ser_array.f
	${F77} ${FLAGS} ser_array.f -o ser_array 

ser_fft.o:  ser_fft.f
	$(F77) $(FLAGS) -c ser_fft.f 

ser_heat2D: ser_heat2D.f
	${F77} ${FLAGS} ser_heat2D.f -o ser_heat2D 

ser_mm: ser_mm.f
	${F77} ${FLAGS} ser_mm.f -o ser_mm 

ser_pi_calc: ser_pi_calc.f
	${F77} ${FLAGS} ser_pi_calc.f -o ser_pi_calc 

ser_prime: ser_prime.f
	${F77} ${FLAGS} ser_prime.f -o ser_prime  -lm

ser_wave: ser_wave.f
	${F77} ${FLAGS} ser_wave.f -o ser_wave -lm

timing_fgettod.o : timing_fgettod.c
	$(CC) $(FLAGS) -c timing_fgettod.c

