!
!1. DO: A simple difference operator
!
!   This example shows a simple parallel loop where the amount
!   of work in each iteration is different.  We use dynamic
!   scheduling to get good load balancing.  The end do has a
!   nowait because there is an implicit barrier at the end parallel.

	subroutine do_1 (a,b,n)
	   real a(n,n), b(n,n)
	

!$omp  parallel
!$omp&     shared       (a,b,n)
!$omp&     private      (i,j)


!$omp  do
!$omp&     schedule     (dynamic, 1)

	 do i = 2, n
	    do j = 1, i
	       b(j,i) = ( a(j,i) + a(j,i-1) ) / 2
	    enddo
	 enddo

!$omp  end do nowait


!$omp  end parallel

	end
