!
!2. DO: Two difference operators
!
!   Shows two parallel regions fused to reduce fork/join
!   overhead.  The first end do has a nowait because all
!   the data used in the second do is different than
!   all the data used in the first do.

	subroutine do_2 (a,b,c,d,m,n)
	   real a(n,n), b(n,n), c(m,m), d(m,m)
	

!$omp  parallel
!$omp&     shared       (a,b,c,d,m,n)
!$omp&     private      (i,j)


!$omp  do
!$omp&     schedule     (dynamic, 1)

	 do i = 2, n
	    do j = 1, i
	       b(j,i) = ( a(j,i) + a(j,i-1) ) / 2
	    enddo
	 enddo

!$omp  end do nowait


!$omp  do
!$omp&     schedule     (dynamic, 1)

	 do i = 2, m
	    do j = 1, i
	       d(j,i) = ( c(j,i) + c(j,i-1) ) / 2
	    enddo
	 enddo

!$omp  end do nowait


!$omp  end parallel

	end
