!
!3. DO: Reduce Fork/Join Overhead
!    
!   Routines do_3a and do_3b perform numerically equivalent computations,
!   but because the PARALLEL directive in routine do_3b is outside the do
!   j loop, routine do_3b probably forms teams less often, and thus reduces 
!   overhead.

	subroutine do_3a (a,b,m,n)
	   real a(n,m), b(n,m)
	
	 do j = 2, m

!$omp  parallel
!$omp&     shared       (a,b,n,j)
!$omp&     private      (i)


!$omp  do

	    do i = 1, n
	       a(i,j) = b(i,j) / a(i,j-1)
	    enddo

!$omp  end do nowait


!$omp  end parallel

	 enddo
	end



	subroutine do_3b (a,b,m,n)
	   real a(n,m), b(n,m)
	

!$omp  parallel
!$omp&     shared       (a,b,m,n)
!$omp&     private      (i,j)

	 do j = 2, m

!$omp  do

	    do i = 1, n
	       a(i,j) = b(i,j) / a(i,j-1)
	    enddo

!$omp  end do

	 enddo

!$omp  end parallel

	end
