!
!4. PSECTIONS: Two difference operators
!
!   Identical to example 2 but using PSECTIONS instead
!   of DO.  Here the speedup is limited to 2 beacuse
!   there are only 2 units of work whereas in example 2
!   there are n-1 + m-1 units of work .

	subroutine psections_1 (a,b,c,d,m,n)
	   real a(n,n), b(n,n), c(m,m), d(m,m)
	

!$omp  parallel
!$omp&     shared       (a,b,c,d,m,n)
!$omp&     private      (i,j)


!$omp  psections


!$omp  section

	 do i = 2, n
	    do j = 1, i
	       b(j,i) = ( a(j,i) + a(j,i-1) ) / 2
	    enddo
	 enddo

!$omp  section

	 do i = 2, m
	    do j = 1, i
	       d(j,i) = ( c(j,i) + c(j,i-1) ) / 2
	    enddo
	 enddo

!$omp  end psections nowait


!$omp  end parallel

	end
