!
!5. SINGLE PROCESS: Updating a shared scalar
!
!   This example demonstrates how to use a SINGLE PROCESS construct
!   to update an element of the shared arry a.  The optional end do
!   after the first do is omitted because we need to wait at the end 
!   of the do before proceeding into the single process section.

	subroutine sp_1a (a,b,n)
	   real a(n), b(n)
	

!$omp  parallel
!$omp&     shared       (a,b,n)
!$omp&     private      (i)


!$omp  do

	 do i = 1, n
	   a(i) = 1.0 / a(i)
	 enddo

!$omp  single

	 a(1) = min( a(1), 1.0 )

!$omp  end single


!$omp  do

	 do i = 1, n
	   b(i) = b(i) / a(i)
	 enddo

!$omp  end do nowait


!$omp  end parallel

	end
