!
!9. BARRIER: Testing then modifying a shared object
!
!   Using a barrier after the first end do instead
!   of synchronizing on array b everywhere.
!   The end do after the first loop is optional but
!   specified in this case.


	subroutine barrier_1 (a,b,c,d,m,n)
	   real a(n,n), b(n,n), c(m,m), d(m,m)
	   real div
	

!$omp  parallel
!$omp&     shared       (a,b,c,d,m,n)
!$omp&     private      (i,j,div)


!$omp  do
!$omp&     schedule     (trapezoidal)

	 do i = 1, n-1
	    do j = 1, i
	       b(j,i) = a(j,i) + a(j,i+1)
	    enddo
	 enddo

!$omp  end do

	 if ( b(1,1) .gt. 100.0 ) then
	     div = 2.0
	 else
	     div = 4.0
	 endif

!$omp  barrier


!$omp  do
!$omp&     schedule     (guided)

	 do i = 1, n
	    do j = 1, i
	       b(j,i) = b(j,i) / div
	    enddo
	 enddo

!$omp  end do nowait


!$omp  end parallel

	end
