!
!10 Simple Reduction
!
!   This demostrates how to perform a reduction using
!   partial sums while avoiding synchronization in the 
!   loop body.

	subroutine reduction_1 (a,m,n,sum)
	   real a(m,n)
	

!$omp  parallel
!$omp&     shared       (a,m,n,sum)
!$omp&     private      (i,j,local_sum)

	 local_sum = 0.0

!$omp  do

	 do i = 1, n
	    do j = 1, m
	       local_sum = local_sum + a(j,i)
	    enddo
	 enddo

!$omp  end do nowait


!$omp  critical

	    sum = sum + local_sum

!$omp  end critical


!$omp  end parallel

	end
