!
!12 INSTANCE PARALLEL: As a shared and then a private common
!
!   This demonstrates the use of an INSTANCE PARALLEL common block
!   first as a shared common block and then as a private common
!   block.  This would not be possible with INSTANCE TASK common
!   blocks since INSTANCE TASK common blocks are always private.

	subroutine ip_2 (n,m)
	   common /shared/ a,b
	   real a(100,100), b(100,100)
	   common /priv/ work
	   real work(10000)
	

!$omp  instanceparallel/priv/


!$omp  parallel		!commonprivissharedheresincenonewapp
!$omp&     shared       (a)
!$omp&     shared       (n,b)
!$omp&     private      (i)


!$omp  do

	 do i = 1, n
	    work(i) = b(i,i) / 4.0
	 enddo

!$omp  end do nowait




!$omp  end parallel

	 do i = 1, n
	    do j = 1, m
	       a(j,i) = work(i) * ( a(j-1,i) + a(j+1,i) + a(j,i-1) + a(j,i+1) )
	    enddo
	 enddo



!$omp  parallel
!$omp&     shared       (m)
!$omp&     private      (i)


!$omp  new/priv/			!thismakesthecommonprivlocal


!$omp  do

	 do i = 1, m
	    call construct_data()	! fills in array work
	    call use_data()		! uses array work
	 enddo

!$omp  end do nowait


!$omp  end parallel

	end
