#include <omp.h>

void reduction_3a (int n, float a[])
{
    int i;
    float gx[8], lx, x;   /* assume 8 processors */

    for(i = 0; i < omp_get_max_threads(); i++)
        gx[i] = 0.0 ;

    #pragma omp parallel shared(a,n) private(i,lx)
    {
        lx = 0.0 ;
        #pragma omp for nowait
        for(i = 0; i < n; i++)
            lx = lx + a[i];

        gx[ omp_get_thread_num() ] = lx;
    }

    x = 0.0 ;
    for(i = 0; i < omp_get_max_threads(); i++)
            x = x + gx[i] ;

    printf("x = \n", x) ;
}
