struct tree {
     struct tree * left;
     struct tree * right;
     struct data * stuff;
};

void noorder( struct tree * node );
void preorder( struct tree * node );
void postorder( struct tree * node );
void inorder( struct tree * node );

void parallel_walks( struct tree * root, 
             int bnoorder, 
             int bpreorder, 
             int bpostorder, 
             int binorder ) 
{ 
     /* only one of noorder, preorder, postorder or inorder should be true */
     #pragma omp parallel taskq
     {
        if( bnoorder ) noorder( root );
        if( bpreorder ) preorder( root );
        if( bpostorder ) postorder( root );
        if( binorder ) inorder( root );
     }
}

void process( struct data * );

void noorder( struct tree * node ) {
     #pragma omp taskq nowait
     {
        #pragma omp task
        process(node->stuff);

        noorder( node->left );
        noorder( node->right );
     }
}

void preorder( struct tree * node ) {
     #pragma omp taskq nowait
     {
        process(node->stuff);
        #pragma omp task
        preorder( node->left );
        #pragma omp task
        preorder( node->right );
     }
}

void postorder( struct tree * node ) {
     #pragma omp taskq
     {
        #pragma omp task
        postorder( node->left );
        #pragma omp task
        postorder( node->right );
     }
     process(node->stuff);
}

void inorder( struct tree * node ) {
     /* this is a completely sequential operation */
     inorder( node->left );
     process(node->stuff);
     inorder( node->right );
}
